diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/sample-random-variable.cc ns-3.36/src/core/examples/sample-random-variable.cc
--- ns-3.35/src/core/examples/sample-random-variable.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/examples/sample-random-variable.cc	2022-04-30 18:23:57.790733000 -0700
@@ -29,8 +29,8 @@
 using namespace ns3;
 
 /**
- * This program can be run from waf such as
- * `./waf --run sample-random-variable`
+ * This program can be run from ns3 such as
+ * `./ns3 run sample-random-variable`
  *
  * This program is about as simple as possible to display the use of ns-3
  * to generate random numbers.  By default, the uniform random variate that
@@ -46,9 +46,9 @@
  * 1. Through explicit call of SeedManager::SetSeed () and
  *    SeedManager::SetRun () (commented out below)
  * 2. Through the passing of command line arguments such as:
- *    ./waf --command-template="%s --RngRun=<value>" --run program-name`
+ *    ./ns3 run program-name --command-template="%s --RngRun=<value>"`
  * 3. Through the use of the NS_GLOBAL_VALUE environment variable, such as:
- *    `$ NS_GLOBAL_VALUE="RngRun=<value>" ./waf --run program-name`
+ *    `$ NS_GLOBAL_VALUE="RngRun=<value>" ./ns3 run program-name`
  *
  * For instance, setting the run number to 3 will change the program output to
  * 0.775417
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/sample-random-variable-stream.cc ns-3.36/src/core/examples/sample-random-variable-stream.cc
--- ns-3.35/src/core/examples/sample-random-variable-stream.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/examples/sample-random-variable-stream.cc	2022-04-30 18:23:57.790733000 -0700
@@ -27,8 +27,8 @@
  * \ingroup randomvariable
  * Example program illustrating use of ns3::RandomVariableStream
  *
- * This program can be run from waf such as
- * `./waf --run sample-random-variable-stream`
+ * This program can be run from ns3 such as
+ * `./ns3 run sample-random-variable-stream`
  *
  * This program is about as simple as possible to display the use of ns-3
  * to generate random numbers.  By default, the uniform random variate that
@@ -44,9 +44,9 @@
  * 1. Through explicit call of SeedManager::SetSeed () and
  *    SeedManager::SetRun () (commented out below)
  * 2. Through the passing of command line arguments such as:
- *    `./waf --command-template="%s --RngRun=<value>" --run program-name`
+ *    `./ns3 run program-name --command-template="%s --RngRun=<value>"`
  * 3. Through the use of the NS_GLOBAL_VALUE environment variable, such as:
- *    `$ NS_GLOBAL_VALUE="RngRun=<value>" ./waf --run program-name`
+ *    `$ NS_GLOBAL_VALUE="RngRun=<value>" ./ns3 run program-name`
  *
  * For instance, setting the run number to 3 will change the program output to
  * 0.775417
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/sample-rng-plot.py ns-3.36/src/core/examples/sample-rng-plot.py
--- ns-3.35/src/core/examples/sample-rng-plot.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/examples/sample-rng-plot.py	2022-04-30 18:23:57.790733000 -0700
@@ -28,13 +28,26 @@
 import ns.core
 
 # mu, var = 100, 225
+
+## Random number generator.
 rng = ns.core.NormalRandomVariable()
 rng.SetAttribute("Mean", ns.core.DoubleValue(100.0))
 rng.SetAttribute("Variance", ns.core.DoubleValue(225.0))
+## Random number samples.
 x = [rng.GetValue() for t in range(10000)]
 
 # the histogram of the data
-n, bins, patches = plt.hist(x, 50, normed=1, facecolor='g', alpha=0.75)
+
+## Make a probability density histogram
+density = 1
+##Â Plot color
+facecolor='g'
+## Plot alpha value (transparency)
+alpha=0.75
+
+# We don't really need the plot results, we're just going to show it later.
+# n, bins, patches = plt.hist(x, 50, density=1, facecolor='g', alpha=0.75)
+plt.hist(x, 50, density=1, facecolor='g', alpha=0.75)
 
 plt.title('ns-3 histogram')
 plt.text(60, .025, r'$\mu=100,\ \sigma=15$')
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/sample-simulator.cc ns-3.36/src/core/examples/sample-simulator.cc
--- ns-3.35/src/core/examples/sample-simulator.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/examples/sample-simulator.cc	2022-04-30 18:23:57.790733000 -0700
@@ -117,6 +117,14 @@
   EventId id = Simulator::Schedule (Seconds (30.0), &CancelledEvent);
   Simulator::Cancel (id);
 
+  Simulator::Schedule (Seconds (25.0),
+    [] ()
+    {
+      std::cout << "Code within a lambda expression at time " 
+                << Simulator::Now ().As (Time::S)
+                << std::endl;
+    });
+
   Simulator::Run ();
 
   Simulator::Destroy ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/examples/sample-simulator.py ns-3.36/src/core/examples/sample-simulator.py
--- ns-3.35/src/core/examples/sample-simulator.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/examples/sample-simulator.py	2022-04-30 18:23:57.790733000 -0700
@@ -44,13 +44,21 @@
         print ("Member method received event at", ns.core.Simulator.Now().GetSeconds(), \
             "s started at", value, "s")
 
+## Example function - starts MyModel.
+## \param [in] model The instance of MyModel
+## \return None.
 def ExampleFunction(model):
     print ("ExampleFunction received event at", ns.core.Simulator.Now().GetSeconds(), "s")
     model.Start()
 
+## Example function - triggered at a random time.
+## \param [in] model The instance of MyModel
+## \return None.
 def RandomFunction(model):
     print ("RandomFunction received event at", ns.core.Simulator.Now().GetSeconds(), "s")
 
+## Example function - triggered if an event is canceled (should not be called).
+## \return None.
 def CancelledEvent():
     print ("I should never be called... ")
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/helper/csv-reader.h ns-3.36/src/core/helper/csv-reader.h
--- ns-3.35/src/core/helper/csv-reader.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/helper/csv-reader.h	2022-04-30 18:23:57.790733000 -0700
@@ -40,7 +40,7 @@
 
 /**
  * \ingroup core
- * \defgroup csvreader
+ * \defgroup csvreader CSV File Reader
  *
  * A way to extract data from simple csv files.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/attribute-accessor-helper.h ns-3.36/src/core/model/attribute-accessor-helper.h
--- ns-3.35/src/core/model/attribute-accessor-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/attribute-accessor-helper.h	2022-04-30 18:23:57.790733000 -0700
@@ -21,7 +21,6 @@
 #define ATTRIBUTE_ACCESSOR_HELPER_H
 
 #include "attribute.h"
-#include "unused.h"
 
 /**
  * \file
@@ -334,10 +333,8 @@
     {}
 
   private:
-    virtual bool DoSet (T *object, const V *v) const
+    virtual bool DoSet ([[maybe_unused]] T *object, [[maybe_unused]] const V *v) const
     {
-      NS_UNUSED (object);
-      NS_UNUSED (v);
       return false;
     }
     virtual bool DoGet (const T *object, V *v) const
@@ -402,10 +399,8 @@
       (object->*m_setter)(tmp);
       return true;
     }
-    virtual bool DoGet (const T *object, V *v) const
+    virtual bool DoGet ([[maybe_unused]] const T *object, [[maybe_unused]] V *v) const
     {
-      NS_UNUSED (object);
-      NS_UNUSED (v);
       return false;
     }
     virtual bool HasGetter (void) const
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/attribute.cc ns-3.36/src/core/model/attribute.cc
--- ns-3.35/src/core/model/attribute.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/attribute.cc	2022-04-30 18:23:57.790733000 -0700
@@ -25,7 +25,7 @@
 
 /**
  * \file
- * \ingroup attribute
+ * \ingroup attributes
  * ns3::AttributeValue, ns3::AttributeAccessor and
  * ns3::AttributeChecker implementations.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/attribute-container-accessor-helper.h ns-3.36/src/core/model/attribute-container-accessor-helper.h
--- ns-3.35/src/core/model/attribute-container-accessor-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/attribute-container-accessor-helper.h	2022-04-30 18:23:57.790733000 -0700
@@ -32,42 +32,76 @@
 namespace ns3 {
 
 /**
- * Compile time check if type T has const iterator.
+ * SFINAE compile time check if type T has const iterator.
  */
-template<typename T>
+template <typename T>
 struct has_const_iterator
 {
 private:
-    typedef char                      yes;
-    typedef struct { char array[2]; } no;
+  /// positive result
+  typedef char yes;
+  /// negative result
+  typedef struct
+  {
+    char array[2]; //!< Check value, its size must be different than the "yes" size
+  } no;
+
+  /**
+   * Test function, compiled if type has a const_iterator
+   * \return A value indicating that this specialization has been compiled.
+   */
+  template <typename C> static yes test (typename C::const_iterator *);
+  /**
+   * Test function, compiled if type does not have a const_iterator
+   * \return A value indicating that this specialization has been compiled.
+   */
+  template <typename C> static no test (...);
 
-    template<typename C> static yes test(typename C::const_iterator*);
-    template<typename C> static no  test(...);
 public:
-    static const bool value = sizeof(test<T>(0)) == sizeof(yes);
-    typedef T type;
+  /// Value of the test - true if type has a const_iterator
+  static const bool value = sizeof (test<T> (0)) == sizeof (yes);
+  /// Equivalent name of the type T
+  typedef T type;
 };
 
 /**
- * Compile time check if type T has begin() and end() methods.
+ * SFINAE compile time check if type T has begin() and end() methods.
  */
 template <typename T>
 struct has_begin_end
 {
-    template<typename C> static char (&f(typename std::enable_if<
-      std::is_same<decltype(static_cast<typename C::const_iterator (C::*)() const>(&C::begin)),
-      typename C::const_iterator(C::*)() const>::value, void>::type*))[1];
-
-    template<typename C> static char (&f(...))[2];
-
-    template<typename C> static char (&g(typename std::enable_if<
-      std::is_same<decltype(static_cast<typename C::const_iterator (C::*)() const>(&C::end)),
-      typename C::const_iterator(C::*)() const>::value, void>::type*))[1];
-
-    template<typename C> static char (&g(...))[2];
-
-    static bool const beg_value = sizeof(f<T>(0)) == 1;
-    static bool const end_value = sizeof(g<T>(0)) == 1;
+  /**
+   * Compiled if type T has a begin() method.
+   * \return A value indicating that this specialization has been compiled.
+   */
+  template <typename C> static char (&f (typename std::enable_if<
+    std::is_same<decltype (static_cast<typename C::const_iterator (C::*) () const> (&C::begin)),
+    typename C::const_iterator (C::*) () const>::value, void>::type *))[1];
+
+  /** 
+   * Compiled if type T does not have a begin() method.
+   * \return A value indicating that this specialization has been compiled.
+   */
+  template <typename C> static char (&f (...))[2];
+
+  /**
+   * Compiled if type T has an end() method.
+   * \return A value indicating that this specialization has been compiled.
+   */
+  template <typename C> static char (&g (typename std::enable_if<
+    std::is_same<decltype (static_cast<typename C::const_iterator (C::*) () const> (&C::end)),
+    typename C::const_iterator (C::*) () const>::value, void>::type *))[1];
+
+  /**
+   * Compiled if type T does not have an end() method.
+   * \return A value indicating that this specialization has been compiled.
+   */
+  template <typename C> static char (&g (...))[2];
+
+  /// True if type T has a begin() method.
+  static bool const beg_value = sizeof (f<T> (0)) == 1;
+  /// True if type T has an end() method.
+  static bool const end_value = sizeof (g<T> (0)) == 1;
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/attribute-container.h ns-3.36/src/core/model/attribute-container.h
--- ns-3.35/src/core/model/attribute-container.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/attribute-container.h	2022-04-30 18:23:57.790733000 -0700
@@ -40,9 +40,9 @@
 /**
  * A container for one type of attribute.
  * 
- * The container uses \ref A to parse items into elements.
+ * The container uses \p A to parse items into elements.
  * Internally the container is always a list but an instance
- * can return the items in a container specified by \ref C.
+ * can return the items in a container specified by \p C.
  * 
  * @tparam A AttributeValue type to be contained.
  * @tparam C Possibly templated container class returned by Get.
@@ -68,7 +68,7 @@
 
   // use underlying AttributeValue to get return element type
   /** Item type of container returned by Get. */
-  typedef typename std::result_of<decltype(&A::Get)(A)>::type item_type;
+  typedef typename std::invoke_result_t<decltype(&A::Get), A> item_type;
   /** Type of container returned. */
   typedef C<item_type> result_type;
 
@@ -80,7 +80,7 @@
 
   /**
    * Construct from another container.
-   * @tparam CONTAINER[deduced] type of container passed for initialization.
+   * @tparam CONTAINER \deduced type of container passed for initialization.
    * \param c Instance of CONTAINER with which to initialize AttributeContainerValue.
    */
   template <class CONTAINER>
@@ -88,7 +88,7 @@
 
   /**
    * Construct from iterators.
-   * @tparam ITER[deduced] type of iterator.
+   * @tparam ITER \deduced type of iterator.
    * \param[in] begin Iterator that points to first initialization item.
    * \param[in] end Iterator that points ones past last initialization item.
    */
@@ -112,8 +112,8 @@
   /**
    * Copy items from container c.
    * 
-   * This method assumes \ref c has stl-style begin and end methods.
-   * The AttributeContainerValue value is cleared before copying from \ref c.
+   * This method assumes \p c has stl-style begin and end methods.
+   * The AttributeContainerValue value is cleared before copying from \p c.
    * @tparam T type of container.
    * \param c Container from which to copy items.
    */
@@ -170,7 +170,7 @@
    * 
    * The internal container is cleared before values are copied
    * using the push_back method.
-   * @tparam ITER[deduced] iterator type
+   * @tparam ITER \deduced iterator type
    * \param[in] begin Points to first item to copy
    * \param[in] end Points to one after last item to copy
    * \return This object with items copied.
@@ -185,16 +185,24 @@
 class AttributeContainerChecker : public AttributeChecker
 {
 public:
+  /**
+   * Set the item checker
+   * \param itemchecker The item checker
+   */
   virtual void SetItemChecker (Ptr<const AttributeChecker> itemchecker) = 0;
+  /**
+   * Get the item checker
+   * \return The item checker
+   */
   virtual Ptr<const AttributeChecker> GetItemChecker (void) const = 0;
 };
 
 /**
  * Make AttributeContainerChecker from AttributeContainerValue.
- * @tparam A[deduced] AttributeValue type in container.
- * @tparam C[deduced] Container type returned by Get.
- * \param value[in] AttributeContainerValue from which to deduce types.
- * \return AttributeContainerChecker for \ref value.
+ * @tparam A \deduced AttributeValue type in container.
+ * @tparam C \deduced Container type returned by Get.
+ * \param[in] value AttributeContainerValue from which to deduce types.
+ * \return AttributeContainerChecker for value.
  */
 template <class A, template <class...> class C>
 Ptr<AttributeChecker>
@@ -204,7 +212,7 @@
  * Make AttributeContainerChecker using explicit types, initialize item checker.
  * @tparam A AttributeValue type in container.
  * @tparam C Container type returned by Get.
- * \param itemchecker[in] AttributeChecker used for each item in the container.
+ * \param[in] itemchecker AttributeChecker used for each item in the container.
  * \return AttributeContainerChecker.
  */
 template <class A, template <class...> class C=std::list>
@@ -220,6 +228,13 @@
 template <class A, template <class...> class C=std::list>
 Ptr<AttributeChecker> MakeAttributeContainerChecker (void);
 
+/**
+ * Make AttributeContainerAccessor  using explicit types.
+ * @tparam A AttributeValue type in container.
+ * @tparam C Container type returned by Get.
+ * \param[in] a1 AttributeContainer to be used.
+ * \return AttributeContainerAccessor.
+ */
 template <typename A, template <typename...> class C=std::list, typename T1>
 Ptr<const AttributeAccessor> MakeAttributeContainerAccessor (T1 a1);
 
@@ -231,23 +246,29 @@
 
 namespace ns3 {
 
-// This internal class defines templated AttributeContainerChecker class that is instantiated
-// in MakeAttributeContainerChecker. The non-templated base ns3::AttributeContainerChecker
-// is returned from that function. This is the same pattern as ObjectPtrContainer.
-
 namespace internal {
 
+/**
+ * \internal
+ * Templated AttributeContainerChecker class that is instantiated
+ * in MakeAttributeContainerChecker. The non-templated base ns3::AttributeContainerChecker
+ * is returned from that function. This is the same pattern as ObjectPtrContainer.
+ */
 template <class A, template <class...> class C>
 class AttributeContainerChecker : public ns3::AttributeContainerChecker
 {
 public:
   AttributeContainerChecker (void);
+  /**
+   * Explicit constructor
+   * \param itemchecker The AttributeChecker.
+   */
   explicit AttributeContainerChecker (Ptr<const AttributeChecker> itemchecker);
   void SetItemChecker (Ptr<const AttributeChecker> itemchecker);
   Ptr<const AttributeChecker> GetItemChecker (void) const;
 
 private:
-  Ptr<const AttributeChecker> m_itemchecker;
+  Ptr<const AttributeChecker> m_itemchecker; //!< The AttributeChecker
 };
 
 template <class A, template <class...> class C>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/attribute.h ns-3.36/src/core/model/attribute.h
--- ns-3.35/src/core/model/attribute.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/attribute.h	2022-04-30 18:23:57.790733000 -0700
@@ -27,7 +27,7 @@
 
 /**
  * \file
- * \ingroup attribute
+ * \ingroup attributes
  * ns3::AttributeValue, ns3::AttributeAccessor and
  * ns3::AttributeChecker declarations.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/calendar-scheduler.h ns-3.36/src/core/model/calendar-scheduler.h
--- ns-3.35/src/core/model/calendar-scheduler.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/calendar-scheduler.h	2022-04-30 18:23:57.790733000 -0700
@@ -204,7 +204,7 @@
    * Ordering function to identify the insertion point, according to \c m_reverse.
    * \param [in] newEvent The new event being inserted.
    * \param [in] it The current position in the bucket being examined.
-   * \return \c true if the \c newEvent belongs before \it.
+   * \return \c true if the \c newEvent belongs before \c it.
    */
   bool (*Order) (const EventKey & newEvent, const EventKey & it);
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/callback.h ns-3.36/src/core/model/callback.h
--- ns-3.35/src/core/model/callback.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/callback.h	2022-04-30 18:23:57.790733000 -0700
@@ -1385,7 +1385,7 @@
    */
   bool IsNull (void) const
   {
-    return (DoPeekImpl () == 0) ? true : false;
+    return (DoPeekImpl () == 0);
   }
   /** Discard the implementation, set it to null */
   void Nullify (void)
@@ -1572,7 +1572,13 @@
         return false;
       }
   }
-  /** \copydoc Assign */
+  /* Broken: \copydoc Callback::Assign() */
+  /**
+   * Adopt the other's implementation, if type compatible
+   *
+   * \param [in] other Callback
+   * \returns \c true if \pname{other} was type-compatible and could be adopted.
+   */
   bool DoAssign (Ptr<const CallbackImplBase> other)
   {
     if (!DoCheckType (other))
@@ -1948,13 +1954,7 @@
   virtual ~CallbackValue ();
   /** \param [in] base The CallbackBase to use */
   void Set (CallbackBase base);
-  /**
-   * Give value my callback, if type compatible
-   *
-   * \tparam T \deduced The type in which to retrieve the value.
-   * \param [out] value Destination callback
-   * \returns \c true if successful
-   */
+  /* Documented by print-introspected-doxygen.cc */
   template <typename T>
   bool GetAccessor (T &value) const;
   /** \return A copy of this CallBack */
@@ -1975,7 +1975,8 @@
   virtual bool DeserializeFromString (std::string value, Ptr<const AttributeChecker> checker);
 
 private:
-  CallbackBase m_value;                 //!< the CallbackBase
+  /* Documented by print-introspected-doxygen.cc */
+  CallbackBase m_value;
 };
 
 ATTRIBUTE_ACCESSOR_DEFINE (Callback);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/command-line.cc ns-3.36/src/core/model/command-line.cc
--- ns-3.35/src/core/model/command-line.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/command-line.cc	2022-04-30 18:23:57.790733000 -0700
@@ -47,6 +47,58 @@
  * ns3::CommandLine implementation.
  */
 
+/** CommandLine anonymous namespace. */
+namespace {
+/**
+ * HTML-encode a string, for PrintDoxygenUsage().
+ * Usage and help strings, which are intended for text-only display,
+ * can contain illegal characters for HTML.  This function 
+ * encodes '&', '\"', '\'',  and '<'.
+ * \param [in] source The original string.
+ * \returns The HTML-encoded version.
+ */
+std::string 
+Encode (const std::string & source)
+{
+  std::string buffer;
+  buffer.reserve (1.1 * source.size ());
+
+  for(size_t pos = 0; pos != source.size (); ++pos) 
+    {
+      /* *NS_CHECK_STYLE_OFF* */
+      switch (source[pos]) 
+        {
+        case '&':  buffer.append ("&amp;");          break;
+        case '\"': buffer.append ("&quot;");         break;
+        case '\'': buffer.append ("&apos;");         break;
+          // case '>':  buffer.append ("&gt;");           break;
+
+        case '<':  {
+          // Special case:
+          // "...blah <file..." is not allowed
+          // "...foo<bar..."  is allowed
+          if (buffer.back () == ' ')
+            {
+              buffer.append ("&lt;");
+            }
+          else
+            {
+              buffer.append ("<");
+            }
+
+          break;
+        }
+
+        default:   buffer.append (&source[pos], 1);  break;
+        }
+      /* *NS_CHECK_STYLE_ON* */
+    }
+  return buffer;
+}
+
+}  // anonymous namespace
+
+
 namespace ns3 {
 
 NS_LOG_COMPONENT_DEFINE ("CommandLine");
@@ -148,7 +200,7 @@
     {
       args.erase (args.begin ());  // discard the program name
 
-      for (auto param : args)
+      for (const auto & param : args)
         {
           if (HandleOption (param))
             {
@@ -382,55 +434,47 @@
 
   std::fstream os (outf, std::fstream::out);
 
-
   os << "/**\n \\file " << m_shortName << ".cc\n"
      << "<h3>Usage</h3>\n"
-     << "<code>$ ./waf --run \"" << m_shortName
+     << "<code>$ ./ns3 run \"" << m_shortName
      << (m_options.size ()  ? " [Program Options]" : "")
      << (nonOptions.size () ? " [Program Arguments]" : "")
      << "\"</code>\n";
 
   if (m_usage.length ())
     {
-      os << m_usage << std::endl;
+      os << Encode (m_usage) << "\n";
     }
 
+  auto listOptions = [&os](Items items, std::string pre)
+  {
+    os << "<dl>\n";
+    for (const auto i : items)
+      {
+        os << "  <dt>" << pre << i->m_name << " </dt>\n"
+           << "    <dd>" << Encode (i->m_help);
+
+        if ( i->HasDefault ())
+          {
+            os << " [" << Encode (i->GetDefault ()) << "]";
+          }
+        os << " </dd>\n";
+      }
+    os << "</dl>\n";
+  };
+
   if (!m_options.empty ())
     {
       os << std::endl;
-      os << "<h3>Program Options</h3>\n"
-         << "<dl>\n";
-      for (auto i : m_options)
-        {
-          os << "  <dt>\\c --" << i->m_name << " </dt>\n"
-             << "    <dd>" << i->m_help;
-
-          if ( i->HasDefault ())
-            {
-              os << " [" << i->GetDefault () << "]";
-            }
-          os << " </dd>\n";
-        }
-      os << "</dl>\n";
+      os << "<h3>Program Options</h3>\n";
+      listOptions (m_options, "\\c --");
     }
 
   if (!nonOptions.empty ())
     {
       os << std::endl;
-      os << "<h3>Program Arguments</h3>\n"
-         << "<dl>\n";
-      for (auto i : nonOptions)
-        {
-          os << "  <dt> \\c " << i->m_name << " </dt>\n"
-             << "    <dd>" << i->m_help;
-
-          if ( i->HasDefault ())
-            {
-              os << " [" << i->GetDefault () << "]";
-            }
-          os << " </dd>\n";
-        }
-      os << "</dl>\n";
+      os << "<h3>Program Arguments</h3>\n";
+      listOptions (nonOptions, "\\c ");
     }
 
   os << "*/" << std::endl;
@@ -450,9 +494,7 @@
   // Sort output
   std::vector<std::string> globals;
 
-  for (GlobalValue::Iterator i = GlobalValue::Begin ();
-       i != GlobalValue::End ();
-       ++i)
+  for (auto i = GlobalValue::Begin(); i != GlobalValue::End(); ++i)
     {
       std::stringstream ss;
       ss << "    --" << (*i)->GetName () << "=[";
@@ -464,28 +506,23 @@
       globals.push_back (ss.str ());
     }
   std::sort (globals.begin (), globals.end ());
-  for (std::vector<std::string>::const_iterator it = globals.begin ();
-       it < globals.end ();
-       ++it)
+  for (const auto & s : globals)
     {
-      os << *it;
+      os << s;
     }
 }
 
 void
-CommandLine::PrintAttributes (std::ostream &os, const std::string &type) const
+CommandLine::PrintAttributeList (std::ostream &os, const TypeId tid, std::stringstream & header) const
 {
   NS_LOG_FUNCTION (this);
 
-  TypeId tid;
-  if (!TypeId::LookupByNameFailSafe (type, &tid))
+  if (!tid.GetAttributeN ())
     {
-      NS_FATAL_ERROR ("Unknown type=" << type << " in --PrintAttributes");
+      return;
     }
-
-  os << "Attributes for TypeId " << tid.GetName () << std::endl;
-
-  // Sort output
+  os << header.str() << "\n";
+  // To sort output
   std::vector<std::string> attributes;
 
   for (uint32_t i = 0; i < tid.GetAttributeN (); ++i)
@@ -493,17 +530,44 @@
       std::stringstream ss;
       ss << "    --" << tid.GetAttributeFullName (i) << "=[";
       struct TypeId::AttributeInformation info = tid.GetAttribute (i);
-      ss << info.initialValue->SerializeToString (info.checker) << "]"
-         << std::endl;
-      ss << "        " << info.help << std::endl;
+      ss << info.initialValue->SerializeToString (info.checker) << "]\n"
+         << "        " << info.help << "\n";
       attributes.push_back (ss.str ());
     }
   std::sort (attributes.begin (), attributes.end ());
-  for (std::vector<std::string>::const_iterator it = attributes.begin ();
-       it < attributes.end ();
-       ++it)
+  for (const auto & s : attributes)
     {
-      os << *it;
+      os << s;
+    }
+}
+
+void
+CommandLine::PrintAttributes (std::ostream &os, const std::string &type) const
+{
+  NS_LOG_FUNCTION (this);
+
+  TypeId tid;
+  if (!TypeId::LookupByNameFailSafe (type, &tid))
+    {
+      NS_FATAL_ERROR ("Unknown type=" << type << " in --PrintAttributes");
+    }
+
+  std::stringstream header;
+  header << "Attributes for TypeId " << tid.GetName ();
+  PrintAttributeList (os, tid, header);
+  header.str("");
+
+  //Parent Attributes
+  if (tid.GetParent () != tid)
+    {
+      TypeId tmp = tid.GetParent ();
+      while (tmp.GetParent () != tmp)
+        {
+          header << "Attributes defined in parent class " << tmp.GetName ();
+          PrintAttributeList (os, tmp, header);
+          header.str("");
+          tmp = tmp.GetParent ();
+        }
     }
 }
 
@@ -529,11 +593,9 @@
       groupTypes.push_back (ss.str ());
     }
   std::sort (groupTypes.begin (), groupTypes.end ());
-  for (std::vector<std::string>::const_iterator it = groupTypes.begin ();
-       it < groupTypes.end ();
-       ++it)
+  for (const auto & s : groupTypes)
     {
-      os << *it;
+      os << s;
     }
 }
 
@@ -554,11 +616,9 @@
       types.push_back (ss.str ());
     }
   std::sort (types.begin (), types.end ());
-  for (std::vector<std::string>::const_iterator it = types.begin ();
-       it < types.end ();
-       ++it)
+  for (const auto & s : types)
     {
-      os << *it;
+      os << s;
     }
 }
 
@@ -576,11 +636,9 @@
 
   os << "Registered TypeId groups:" << std::endl;
   // Sets are already sorted
-  for (std::set<std::string>::const_iterator k = groups.begin ();
-       k != groups.end ();
-       ++k)
+  for (const auto & s : groups)
     {
-      os << "    " << *k << std::endl;
+      os << "    " << s << std::endl;
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/command-line.h ns-3.36/src/core/model/command-line.h
--- ns-3.35/src/core/model/command-line.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/command-line.h	2022-04-30 18:23:57.794733300 -0700
@@ -26,6 +26,7 @@
 
 #include "callback.h"
 #include "nstime.h"
+#include "type-id.h"
 
 /**
  * \file
@@ -155,19 +156,19 @@
  * Here is the output from a few runs of that program:
  *
  * \verbatim
-   $ ./waf --run="command-line-example"
+   $ ./ns3 run="command-line-example"
    intArg:   1
    boolArg:  false
    strArg:   "strArg default"
    cbArg:    "cbArg default"
 
-   $ ./waf --run="command-line-example --intArg=2 --boolArg --strArg=Hello --cbArg=World"
+   $ ./ns3 run="command-line-example --intArg=2 --boolArg --strArg=Hello --cbArg=World"
    intArg:   2
    boolArg:  true
    strArg:   "Hello"
    cbArg:    "World"
 
-   $ ./waf --run="command-line-example --help"
+   $ ./ns3 run="command-line-example --help"
    ns3-dev-command-line-example-debug [Program Arguments] [General Arguments]
 
    CommandLine example program.
@@ -538,13 +539,22 @@
    */
   void PrintGlobals (std::ostream &os) const;
   /**
-   * Handler for \c \--PrintAttributes:  print the attributes for a given type.
+   * Handler for \c \--PrintAttributes:  print the attributes for a given type
+   * as well as its parents.
    *
    * \param [in,out] os the output stream.
-   * \param [in] type The TypeId whose Attributes should be displayed
+   * \param [in] type The type name whose Attributes should be displayed,
    */
   void PrintAttributes (std::ostream &os, const std::string &type) const;
   /**
+   * Print the Attributes for a single type.
+   *
+   * \param [in,out] os the output stream.
+   * \param [in] tid The TypeId whose Attributes should be displayed,
+   * \param [in] header A header line to print if \c tid has Attributes
+   */
+  void PrintAttributeList (std::ostream &os, const TypeId tid, std::stringstream & header) const;
+  /**
    * Handler for \c \--PrintGroup:  print all types belonging to a given group.
    *
    * \param [in,out] os The output stream.
@@ -574,6 +584,7 @@
   /**
    * Append usage message in Doxygen format to the file indicated
    * by the NS_COMMANDLINE_INTROSPECTION environment variable.
+   * This is typically only called once, by Parse().
    */
   void PrintDoxygenUsage (void) const;
 
@@ -583,7 +594,7 @@
   std::size_t m_NNonOptions;            /**< The expected number of non-option arguments */
   std::size_t m_nonOptionCount;         /**< The number of actual non-option arguments seen so far. */
   std::string m_usage;                  /**< The Usage string */
-  std::string m_shortName;              /**< The source file name (without `.cc`), as would be given to `waf --run` */
+  std::string m_shortName;              /**< The source file name (without `.cc`), as would be given to `ns3 run` */
 
 };  // class CommandLine
 
@@ -603,7 +614,7 @@
  *
  * \param [in] value The argument name
  * \param [out] val The argument location
- * \tparam \deduced T The type being specialized
+ * \tparam T \deduced The type being specialized
  * \return \c true if parsing was successful
  */
 template <typename T>
@@ -695,7 +706,7 @@
 bool
 CommandLine::UserItem<T>::HasDefault () const
 {
-  return true;
+  return (m_default.size () > 0);
 }
 
 template <typename T>
